import UIKit
import Foundation
import CoreLocation
import QuartzCore
import CoreGraphics
import SystemConfiguration
import TLPhotoPicker

let SCREEN_WIDTH = UIScreen.main.bounds.width
let SCREEN_HEIGHT = UIScreen.main.bounds.height
let storyBoard = UIStoryboard.init(name: "Main", bundle: nil)
let appDelegate = UIApplication.shared.delegate as! AppDelegate

let BANNER_ADID = "ca-app-pub-3940256099942544/2934735716"
let FULL_ADID = "ca-app-pub-3940256099942544/4411468910"
let APPOPENADID = "ca-app-pub-3940256099942544/5662855259"
let APP_NATIVE = "ca-app-pub-3940256099942544/3986624511"

let appID = "app ID"
let devURL = "developer URL"
let Mail_ID = "support mail"
var RateURL : String = "app URL"

var AppName = "Cam Scanner"
var PDFFileName = "FinalPDF"

let ShadowColor = UIColor.init(named: "ShadowColor")!
let FontColor = UIColor.init(named: "FontColor")!
let BGColor = UIColor.init(named: "BGColor")!
let ThemeColor = UIColor.init(named: "ThemeColor")!

var bottomPadding: CGFloat = UIApplication.shared.keyWindow?.safeAreaInsets.bottom ?? 0.0
var topPadding: CGFloat = UIApplication.shared.keyWindow?.safeAreaInsets.top ?? 0.0

class MyFunc: NSObject
{
    func convertImageToBase64(image: UIImage) -> String {
        let imageData = image.pngData()!
        return imageData.base64EncodedString(options: Data.Base64EncodingOptions.lineLength64Characters)
    }

    func convertBase64ToImage(imageString: String) -> UIImage {
        let imageData = Data(base64Encoded: imageString, options: Data.Base64DecodingOptions.ignoreUnknownCharacters)!
        return UIImage(data: imageData)!
    }
}

class UserDefaultMgr
{
    class func setSortType(strId: Int)
    {
        UserDefaults.standard.setValue(strId, forKey: "sortType")
        UserDefaults.standard.synchronize()
    }
    class func getSortType() -> Int{
        if UserDefaults.standard.object(forKey: "sortType") == nil{
            return 0
        }
        return UserDefaults.standard.value(forKey: "sortType") as! Int
    }
    
    
    class func getIsDoc4Time() -> Int{
        if UserDefaults.standard.object(forKey: "ad_DocCount") == nil{
            return 0
        }
        return UserDefaults.standard.value(forKey: "ad_DocCount") as! Int
    }
    class func setIsDoc4Time(strId: Int)
    {
        UserDefaults.standard.setValue(strId, forKey: "ad_DocCount")
        UserDefaults.standard.synchronize()
    }
    
    class func getIsOCROneTime() -> Int{
        if UserDefaults.standard.object(forKey: "ad_OCRcount") == nil{
            return 0
        }
        return UserDefaults.standard.value(forKey: "ad_OCRcount") as! Int
    }
    class func setIsOCROneTime(strId: Int)
    {
        UserDefaults.standard.setValue(strId, forKey: "ad_OCRcount")
        UserDefaults.standard.synchronize()
    }
    
    class func setIsChangeLayout(type: Bool){
        UserDefaults.standard.setValue(type, forKey: "isChangeLayout")
        UserDefaults.standard.synchronize()
    }
    class func getIsChangeLayout() -> Bool{
        if UserDefaults.standard.object(forKey: "isChangeLayout") == nil{
            setIsChangeLayout(type: false)
            return false
        }
        return UserDefaults.standard.value(forKey: "isChangeLayout") as! Bool
    }
    
    class func setIsPasscode(type: Bool){
        UserDefaults.standard.setValue(type, forKey: "isPasscode")
        UserDefaults.standard.synchronize()
    }
    
    class func getIsPasscode() -> Bool{
        if UserDefaults.standard.object(forKey: "isPasscode") == nil{
            setIsPasscode(type: false)
            return false
        }
        return UserDefaults.standard.value(forKey: "isPasscode") as! Bool
    }
    
    class func setIsFaceID(type: Bool){
        UserDefaults.standard.setValue(type, forKey: "isFaceID")
        UserDefaults.standard.synchronize()
    }
    
    class func getIsFaceID() -> Bool{
        if UserDefaults.standard.object(forKey: "isFaceID") == nil{
            setIsFaceID(type: false)
            return false
        }
        return UserDefaults.standard.value(forKey: "isFaceID") as! Bool
    }
    
    
    class func setIsTouchID(type: Bool){
        UserDefaults.standard.setValue(type, forKey: "isTouchID")
        UserDefaults.standard.synchronize()
    }
    
    class func getIsTouchID() -> Bool{
        if UserDefaults.standard.object(forKey: "isTouchID") == nil{
            setIsTouchID(type: false)
            return false
        }
        return UserDefaults.standard.value(forKey: "isTouchID") as! Bool
    }
    
}


let aloaderSpinnerMarginSide : CGFloat = 35.0
let aloaderSpinnerMarginTop : CGFloat = 20.0
let aloaderTitleMargin : CGFloat = 5.0

let maxCount = 6


open class ProcessLoader : UIView {
    
    fileprivate var coverView : UIView?
    fileprivate var titleLabel : UILabel?
    fileprivate var loadingView : SwiftLoadingView?
    fileprivate var animated : Bool = true
    fileprivate var canUpdated = false
    fileprivate var title: String?
    fileprivate var speed = 1
    
    fileprivate var config : Config = Config() {
        didSet {
            self.loadingView?.config = config
        }
    }
    
    @objc func rotated(_ notification: Notification) {
        
        let loader = ProcessLoader.sharedInstance
        
        let height : CGFloat = UIScreen.main.bounds.size.height
        let width : CGFloat = UIScreen.main.bounds.size.width
        let center : CGPoint = CGPoint(x: width / 2.0, y: height / 2.0)
        
        loader.center = center
        loader.coverView?.frame = UIScreen.main.bounds
    }
    
    override open var frame : CGRect {
        didSet {
            self.update()
        }
    }
    
    class var sharedInstance: ProcessLoader {
        struct Singleton {
            static let instance = ProcessLoader(frame: CGRect(origin: CGPoint(x: 0,y: 0),size: CGSize(width: Config().size,height: Config().size)))
        }
        return Singleton.instance
    }
    
    open class func show(animated: Bool) {
        self.show(title: nil, animated: animated)
    }
    
    open class func show(title: String?, animated : Bool) {
        
        let currentWindow : UIWindow = UIApplication.shared.keyWindow!
        
        let loader = ProcessLoader.sharedInstance
        loader.canUpdated = true
        loader.animated = animated
        loader.title = title
        loader.update()
                
        let height : CGFloat = UIScreen.main.bounds.size.height
        let width : CGFloat = UIScreen.main.bounds.size.width
        let center : CGPoint = CGPoint(x: width / 2.0, y: height / 2.0)
        
        loader.center = center
        
        if (loader.superview == nil) {
            loader.coverView = UIView(frame: currentWindow.bounds)
            loader.coverView?.backgroundColor = loader.config.foregroundColor.withAlphaComponent(loader.config.foregroundAlpha)
            
            currentWindow.addSubview(loader.coverView!)
            currentWindow.addSubview(loader)
            loader.start()
        }
    }
    
    open class func hide() {
        
        let loader = ProcessLoader.sharedInstance
        NotificationCenter.default.removeObserver(loader)
        
        loader.stop()
    }
    
    public class func setConfig(config : Config) {
        let loader = ProcessLoader.sharedInstance
        loader.config = config
        loader.frame = CGRect(origin: CGPoint(x: 0, y: 0),size: CGSize(width: loader.config.size, height: loader.config.size))
    }
    
    private func setup() {
        self.alpha = 0
        self.update()
    }
    
    private func start() {
        self.loadingView?.start()
        
        if (self.animated) {
            UIView.animate(withDuration: 0.3, animations: { () -> Void in
                self.alpha = 1
                }, completion: { (finished) -> Void in
                    
            });
        } else {
            self.alpha = 1
        }
    }
    
    private func stop() {
        
        DispatchQueue.main.async {
            if (self.animated) {
                UIView.animate(withDuration: 0.3, animations: { () -> Void in
                    self.alpha = 0
                }, completion: { (finished) -> Void in
                    self.removeFromSuperview()
                    self.coverView?.removeFromSuperview()
                    self.loadingView?.stop()
                });
            } else {
                self.alpha = 0
                self.removeFromSuperview()
                self.coverView?.removeFromSuperview()
                self.loadingView?.stop()
            }
        }
    }
    
    private func update() {
        self.backgroundColor = self.config.backgroundColor
        self.layer.cornerRadius = self.config.cornerRadius
        let loadingViewSize = self.frame.size.width - (aloaderSpinnerMarginSide * 2)
        
        if (self.loadingView == nil) {
            self.loadingView = SwiftLoadingView(frame: self.frameForSpinner())
            self.addSubview(self.loadingView!)
        } else {
            self.loadingView?.frame = self.frameForSpinner()
        }
        
        if (self.titleLabel == nil) {
            self.titleLabel = UILabel(frame: CGRect(origin: CGPoint(x: aloaderTitleMargin, y: aloaderSpinnerMarginTop + loadingViewSize), size: CGSize(width: self.frame.width - aloaderTitleMargin*2, height:  42.0)))
            self.addSubview(self.titleLabel!)
            self.titleLabel?.numberOfLines = 1
            self.titleLabel?.textAlignment = NSTextAlignment.center
            self.titleLabel?.adjustsFontSizeToFitWidth = true
        } else {
            self.titleLabel?.frame = CGRect(origin: CGPoint(x: aloaderTitleMargin, y: aloaderSpinnerMarginTop + loadingViewSize), size: CGSize(width: self.frame.width - aloaderTitleMargin*2, height: 42.0))
        }
        
        self.titleLabel?.font = self.config.titleTextFont
        self.titleLabel?.textColor = self.config.titleTextColor
        self.titleLabel?.text = self.title
        
        self.titleLabel?.isHidden = self.title == nil
    }
    
    func frameForSpinner() -> CGRect {
        let loadingViewSize = self.frame.size.width - (aloaderSpinnerMarginSide * 2)
        
        if (self.title == nil) {
            let yOffset = (self.frame.size.height - loadingViewSize) / 2
            return CGRect(origin: CGPoint(x: aloaderSpinnerMarginSide, y: yOffset), size: CGSize(width: loadingViewSize, height: loadingViewSize))
        }
        return CGRect(origin: CGPoint(x: aloaderSpinnerMarginSide, y: aloaderSpinnerMarginTop), size: CGSize(width: loadingViewSize, height: loadingViewSize))
    }
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.setup()
    }
    
    required public init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
    }
    
    class SwiftLoadingView : UIView {
        
        fileprivate var speed : Int?
        fileprivate var lineWidth : Float?
        fileprivate var lineTintColor : UIColor?
        fileprivate var backgroundLayer : CAShapeLayer?
        fileprivate var isSpinning : Bool?
        
        var config : Config = Config() {
            didSet {
                self.update()
            }
        }
        
        override init(frame: CGRect) {
            super.init(frame: frame)
            self.setup()
        }
        
        required init?(coder aDecoder: NSCoder) {
            super.init(coder: aDecoder)
        }
        
        func setup() {
            self.backgroundColor = UIColor.clear
            self.lineWidth = fmaxf(Float(self.frame.size.width) * 0.025, 1)
            
            self.backgroundLayer = CAShapeLayer()
            self.backgroundLayer?.strokeColor = self.config.spinnerColor.cgColor
            self.backgroundLayer?.fillColor = self.backgroundColor?.cgColor
            self.backgroundLayer?.lineCap = CAShapeLayerLineCap.round
            self.backgroundLayer?.lineWidth = CGFloat(self.lineWidth!)
            self.layer.addSublayer(self.backgroundLayer!)
        }
        
        func update() {
            self.lineWidth = self.config.spinnerLineWidth
            self.speed = self.config.speed
            
            self.backgroundLayer?.lineWidth = CGFloat(self.lineWidth!)
            self.backgroundLayer?.strokeColor = self.config.spinnerColor.cgColor
        }
        
        override func draw(_ rect: CGRect) {
            self.backgroundLayer?.frame = self.bounds
        }
        
        func drawBackgroundCircle(_ partial : Bool) {
            let startAngle : CGFloat = .pi / CGFloat(2.0)
            var endAngle : CGFloat = (2.0 * .pi) + startAngle
            
            let center : CGPoint = CGPoint(x: self.bounds.size.width / 2,y: self.bounds.size.height / 2)
            let radius : CGFloat = (CGFloat(self.bounds.size.width) - CGFloat(self.lineWidth!)) / CGFloat(2.0)
            
            let processBackgroundPath : UIBezierPath = UIBezierPath()
            processBackgroundPath.lineWidth = CGFloat(self.lineWidth!)
            
            if (partial) {
                endAngle = (1.8 * .pi) + startAngle
            }
            
            processBackgroundPath.addArc(withCenter: center, radius: radius, startAngle: startAngle, endAngle: endAngle, clockwise: true)
            self.backgroundLayer?.path = processBackgroundPath.cgPath;
        }
        
        func start() {
            self.isSpinning? = true
            self.drawBackgroundCircle(true)
            
            let rotationAnimation : CABasicAnimation = CABasicAnimation(keyPath: "transform.rotation.z")
            rotationAnimation.toValue = NSNumber(value: .pi * 2.0)
            rotationAnimation.duration = 1;
            rotationAnimation.isCumulative = true;
            rotationAnimation.repeatCount = HUGE;
            self.backgroundLayer?.add(rotationAnimation, forKey: "rotationAnimation")
        }
        
        func stop() {
            self.drawBackgroundCircle(false)
            self.backgroundLayer?.removeAllAnimations()
            self.isSpinning? = false
        }
    }
    
    public struct Config {
        public var size : CGFloat = 120.0
        public var spinnerColor = BGColor
        public var spinnerLineWidth :Float = 1.0
        public var titleTextColor = UIColor.black
        public var speed :Int = 1
        public var titleTextFont : UIFont = UIFont.boldSystemFont(ofSize: 16.0)
        public var backgroundColor = FontColor
        public var foregroundColor = UIColor.clear
        public var foregroundAlpha:CGFloat = 0.0
        public var cornerRadius : CGFloat = 10.0
        public init() {}
    }
}

extension UIView {
        
    func roundCorners(corners: UIRectCorner, radius: CGFloat) {
        let path = UIBezierPath(roundedRect: bounds, byRoundingCorners: corners, cornerRadii: CGSize(width: radius, height: radius))
        let mask = CAShapeLayer()
        mask.path = path.cgPath
        layer.mask = mask
    }
    
    func addShadow(offset: CGSize, color: UIColor, radius: CGFloat, opacity: Float) {
        layer.masksToBounds = false
        layer.shadowOffset = offset
        layer.shadowColor = color.cgColor
        layer.shadowRadius = radius
        layer.shadowOpacity = opacity

        let backgroundCGColor = backgroundColor?.cgColor
        backgroundColor = nil
        layer.backgroundColor =  backgroundCGColor
    }
    
    
    func addFixShadow() {
        layer.masksToBounds = false
        layer.shadowOffset = CGSize.init(width: 2.0, height: 2.0)
        layer.shadowColor = ShadowColor.cgColor
        layer.shadowRadius = 4.0
        layer.shadowOpacity = 0.5

        let backgroundCGColor = backgroundColor?.cgColor
        backgroundColor = nil
        layer.backgroundColor =  backgroundCGColor
    }
}

extension Array {
  mutating func remove(at indexes: [Int]) {
    for index in indexes.sorted(by: >) {
      remove(at: index)
    }
  }
}

extension Sequence where Element: Hashable {
    func uniqued() -> [Element] {
        var set = Set<Element>()
        return filter { set.insert($0).inserted }
    }
}

extension UIViewController {

    func showAlertWithTitle( alertTitle : String , msg:String )
    {
        let alert = UIAlertController(title:alertTitle, message: msg, preferredStyle: .alert)
        let action = UIAlertAction(title: "OK", style: .cancel, handler: nil)
        alert.addAction(action)
        self.present(alert, animated: true, completion: nil)
        
    }
    
    func OpenPhotosPicker(_ self : UIViewController){
        
        let TLController = TLPhotosPickerViewController()
        TLController.delegate = self as? TLPhotosPickerViewControllerDelegate
        TLController.didExceedMaximumNumberOfSelection = { [weak self] (picker) in
            
            let alert = UIAlertController(title: "", message: "Exceed Maximum Number Of Selection", preferredStyle: .alert)
            alert.addAction(UIAlertAction(title: "Ok", style: .default, handler: nil))
            self!.present(alert, animated: true, completion: nil)
        }
        
        var configure = TLPhotosPickerConfigure()
        configure.numberOfColumn = 3
        configure.usedCameraButton = false
        configure.mediaType = .image
        configure.maxSelectedAssets = 50
        TLController.configure = configure
        TLController.selectedAssets.removeAll()
        TLController.logDelegate = self  as? TLPhotosPickerLogDelegate
        
        if let popoverController = TLController.popoverPresentationController {
            popoverController.sourceView = self.view
            popoverController.sourceRect = CGRect(x: self.view.bounds.midX, y: self.view.bounds.midY, width: 0, height: 0)
        }
        TLController.modalPresentationStyle = .fullScreen
        self.present(TLController, animated: true, completion: nil)
    }
}


extension UIApplication
{
    class func topViewController(controller: UIViewController? = UIApplication.shared.keyWindow?.rootViewController) -> UIViewController? {
        if let navigationController = controller as? UINavigationController {
            return topViewController(controller: navigationController.visibleViewController)
        }
        if let tabController = controller as? UITabBarController {
            if let selected = tabController.selectedViewController {
                return topViewController(controller: selected)
            }
        }
        if let presented = controller?.presentedViewController {
            return topViewController(controller: presented)
        }
        return controller
    }

    class func getTopViewController(base: UIViewController? = UIApplication.shared.keyWindow?.rootViewController) -> UIViewController? {

        if let nav = base as? UINavigationController {
            return getTopViewController(base: nav.visibleViewController)

        } else if let tab = base as? UITabBarController, let selected = tab.selectedViewController {
            return getTopViewController(base: selected)

        } else if let presented = base?.presentedViewController {
            return getTopViewController(base: presented)
        }
        return base
    }
}


extension UIColor {
            
    public convenience init?(hexString: String) {
        var cString: String = hexString.trimmingCharacters(in: CharacterSet.whitespacesAndNewlines).uppercased()
        
        if (cString.hasPrefix("#")) {
            if let range = cString.range(of: cString) {
                cString = cString.substring(from: cString.index(range.lowerBound, offsetBy: 1))
            }
        }
        
        if ((cString.count) != 6) {
            self.init(white: 0.2, alpha: 1)
            return
        }
        
        var rgbValue: UInt32 = 0
        Scanner(string: cString).scanHexInt32(&rgbValue)
        
        self.init(
            red: CGFloat((rgbValue & 0xFF0000) >> 16) / 255.0,
            green: CGFloat((rgbValue & 0x00FF00) >> 8) / 255.0,
            blue: CGFloat(rgbValue & 0x0000FF) / 255.0,
            alpha: CGFloat(1.0)
        )
    }
}

extension UIView {

    var height:CGFloat{return self.bounds.size.height}
    var width:CGFloat{return self.bounds.size.width}
    var x:CGFloat{return self.frame.origin.x}
    var y:CGFloat{return self.frame.origin.y}

    func MoveToXwithDuration(toX:CGFloat,duration:Double) {
        UIView.animate(withDuration: duration) {
            self.frame.origin.x = toX
        }
    }
    
    func MoveToYwithDuration(toY:CGFloat,duration:Double) {
        
        UIView.animate(withDuration: duration) {
            self.frame.origin.y = toY
        }
    }
    
    @IBInspectable
    var cornerRadiuss: CGFloat {
        get {
            return layer.cornerRadius
        }
        set {
            layer.cornerRadius = newValue
        }
    }
    
    @IBInspectable
    var borderWidth: CGFloat {
        get
        {
            return layer.borderWidth
        }
        set
        {
            layer.borderWidth = newValue
        }
    }
    
    @IBInspectable
    var borderColor: UIColor? {
        get {
            if let color = layer.borderColor {
                return UIColor(cgColor: color)
            }
            return nil
        }
        set {
            if let color = newValue {
                layer.borderColor = color.cgColor
            } else {
                layer.borderColor = nil
            }
        }
    }
    
    //FIND The parent view from UIVIEW
    var parentViewController: UIViewController? {
        var parentResponder: UIResponder? = self
        while parentResponder != nil {
            parentResponder = parentResponder!.next
            if let viewController = parentResponder as? UIViewController {
                return viewController
            }
        }
        return nil
    }
    
    func TakeScreenshot() -> UIImage {

        UIGraphicsBeginImageContextWithOptions(self.bounds.size, false, UIScreen.main.scale)
        drawHierarchy(in: self.bounds, afterScreenUpdates: true)
        let image = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        if (image != nil)
        {
            return image!
        }
        return UIImage()
    }
}

extension Int
{
    var FloatValue:CGFloat{return CGFloat(self)}
    var DoubleValue:Double{return Double(self)}
}


extension UIImage{

    var height:CGFloat{return self.size.height}
    var width:CGFloat{return self.size.width}
    
    func resizeImage(targetSize: CGSize) -> UIImage? {
        let size = self.size
        
        let widthRatio  = targetSize.width  / size.width
        let heightRatio = targetSize.height / size.height
        
        // Figure out what our orientation is, and use that to form the rectangle
        var newSize: CGSize
        if(widthRatio > heightRatio) {
            newSize = CGSize(width: size.width * heightRatio, height: size.height * heightRatio)
        } else {
            newSize = CGSize(width: size.width * widthRatio, height: size.height * widthRatio)
        }
        
        // This is the rect that we've calculated out and this is what is actually used below
        let rect = CGRect(origin: .zero, size: newSize)
        
        // Actually do the resizing to the rect using the ImageContext stuff
        UIGraphicsBeginImageContextWithOptions(newSize, false, 1.0)
        self.draw(in: rect)
        let newImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        
        return newImage
    }
    
    func BlurImage(value:NSNumber) -> UIImage {
        
        let context = CIContext(options: [CIContextOption.useSoftwareRenderer:true])
        let CIImage = CoreImage.CIImage(image:self)
        let blurFilter = CIFilter(name: "CIGaussianBlur")
        blurFilter?.setValue(CIImage, forKey: kCIInputImageKey)
        blurFilter?.setValue(value, forKey: "inputRadius")
        let imageRef = context.createCGImage((blurFilter?.outputImage)!, from: (CIImage?.extent)!)
        
        let newImage = UIImage(cgImage:imageRef!)
        return newImage
    }
    
    func fixImageOrientation()->UIImage {
        UIGraphicsBeginImageContext(self.size)
        self.draw(at: .zero)
        let newImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        return newImage ?? self
    }
}

extension String
{
    var toInteger:Int?{
        get{
            return Int(self)
        }
    }
    
    var toDouble:Double?{
        get{
            return Double(self)
        }
    }
    
    var toFloat:Float?{
        get{
            return Float(self)
        }
    }
    
    var toBool:Bool?{
        get
        {
            if self == "1"
            {
                return "1" == self ?  true : false
            }
            return "true" == self ?  true : false
        }
    }
}

extension CGFloat
{
    var toInt:Int?{
        get{
            return Int(self)
        }
    }
}


struct ImageHeaderData{
    static var PNG: [UInt8] = [0x89]
    static var JPEG: [UInt8] = [0xFF]
    static var GIF: [UInt8] = [0x47]
    static var TIFF_01: [UInt8] = [0x49]
    static var TIFF_02: [UInt8] = [0x4D]
}

enum ImageFormat{
    case Unknown, PNG, JPEG, GIF, TIFF
}


extension NSData{
    var imageFormat: ImageFormat{
        var buffer = [UInt8](repeating: 0, count: 1)
        self.getBytes(&buffer, range: NSRange(location: 0,length: 1))
        if buffer == ImageHeaderData.PNG
        {
            return .PNG
        } else if buffer == ImageHeaderData.JPEG
        {
            return .JPEG
        } else if buffer == ImageHeaderData.GIF
        {
            return .GIF
        } else if buffer == ImageHeaderData.TIFF_01 || buffer == ImageHeaderData.TIFF_02{
            return .TIFF
        } else{
            return .Unknown
        }
    }
}
